Index: trunk/LMDZ.MARS/libf/aeronomars/calchim.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 1266)
@@ -67,10 +67,6 @@
 !=======================================================================
 
-!#include "dimensions.h"
-!#include "dimphys.h"
 #include "chimiedata.h"
-!#include "tracer.h"
 #include "callkeys.h"
-!#include "conc.h"
 
 !     input:
@@ -668,6 +664,6 @@
         
          if (thermochem) then
-            call chemthermos(ig,lswitch,chemthermod,zycol,ztemp,zdens,  &
-                             zpress,zlocal,szacol,ptimestep,zday)
+            call chemthermos(ig,nlayer,lswitch,chemthermod,zycol,ztemp,&
+                             zdens,zpress,zlocal,szacol,ptimestep,zday)
          end if
 
Index: trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90	(revision 1266)
@@ -1,4 +1,4 @@
-      SUBROUTINE chemthermos(ig,lswitch,chemthermod,zycol,ztemp,zdens,  &
-           zpress,zlocal,zenit,ptimestep,zday)
+      SUBROUTINE chemthermos(ig,nlayer,lswitch,chemthermod,zycol,ztemp, &
+           zdens,zpress,zlocal,zenit,ptimestep,zday)
 
       use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,  &
@@ -30,20 +30,14 @@
 !    ------------------
 !
-#include "dimensions.h"
-#include "dimphys.h"
 #include "callkeys.h"
-!#include "comdiurn.h"
-#include "param.h"
-#include "param_v4.h"
-!#include"tracer.h"
 !-----------------------------------------------------------------------
 !    Input/Output
 !    ------------
-      integer :: lswitch,ig,chemthermod
-      real :: zycol(nlayermx,nqmx)
-      real :: ztemp(nlayermx)
-      real :: zdens(nlayermx)
-      real :: zpress(nlayermx)			! in mbar
-      real :: zlocal(nlayermx)
+      integer :: lswitch,ig,chemthermod,nlayer
+      real :: zycol(nlayer,nqmx)
+      real :: ztemp(nlayer)
+      real :: zdens(nlayer)
+      real :: zpress(nlayer)			! in mbar
+      real :: zlocal(nlayer)
       real :: zenit
       real :: ptimestep
@@ -426,7 +420,7 @@
 
       !Allocate density vector
-      allocate(rm(nlayermx,nesptherm))
-
-      do l=1,nlayermx
+      allocate(rm(nlayer,nesptherm))
+
+      do l=1,nlayer
         rm(l,i_co2)     = max(zycol(l,g_co2)*zdens(l),1.e-30)
         rm(l,i_co)      = max(zycol(l,g_co)*zdens(l),1.e-30) 
@@ -474,7 +468,7 @@
       call flujo(solarcondate)
       if(solvarmod.eq.0) then
-         call jthermcalc(ig,chemthermod,rm,nesptherm,ztemp,zlocal,zenit)
+         call jthermcalc(ig,nlayer,chemthermod,rm,nesptherm,ztemp,zlocal,zenit)
       else if(solvarmod.eq.1) then
-         call jthermcalc_e107(ig,chemthermod,rm,nesptherm,ztemp,zlocal,zenit,zday)
+         call jthermcalc_e107(ig,nlayer,chemthermod,rm,nesptherm,ztemp,zlocal,zenit,zday)
       endif
          
@@ -482,8 +476,8 @@
       !Chemistry
       call paramfoto_compact  &
-           (ig,chemthermod,lswitch,ztemp,ptimestep,zenit,zlocal,rm,nesptherm)
+           (ig,nlayer,chemthermod,lswitch,ztemp,ptimestep,zenit,zlocal,rm,nesptherm)
 
       !Concentrations back to GCM
-      do l=lswitch,nlayermx
+      do l=lswitch,nlayer
         zycol(l,g_co2)     = max(rm(l,i_co2)     / zdens(l) , 1.e-30)
         zycol(l,g_co)      = max(rm(l,i_co)      / zdens(l) , 1.e-30)
Index: trunk/LMDZ.MARS/libf/aeronomars/chemthermos_readini.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/chemthermos_readini.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/chemthermos_readini.F	(revision 1266)
@@ -1,15 +1,6 @@
       subroutine chemthermos_readini
 
+      use param_v4_h, only: rcoef
       implicit none
-
-
-c     common variables and constants
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-      include 'datafile.h'
-      include "callkeys.h"
-
 
 c     local variables
Index: trunk/LMDZ.MARS/libf/aeronomars/concentrations.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/concentrations.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/concentrations.F	(revision 1266)
@@ -27,11 +27,6 @@
 !     declarations
  
-!#include "dimensions.h"
-!#include "dimphys.h"
 #include "callkeys.h"
-!#include "comdiurn.h"
 #include "chimiedata.h"
-!#include "tracer.h"
-!#include "conc.h"
 
 !     input/output
Index: trunk/LMDZ.MARS/libf/aeronomars/conduction.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/conduction.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/conduction.F	(revision 1266)
@@ -16,10 +16,4 @@
 c   declarations:
 c-----------------------------------------------------------------------
-
-!#include "dimensions.h"
-!#include "dimphys.h"
-!#include "surfdat.h"
-!#include "chimiedata.h"
-!#include "conc.h"
 
 c   arguments:
Index: trunk/LMDZ.MARS/libf/aeronomars/deposition.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/deposition.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/deposition.F	(revision 1266)
@@ -12,9 +12,4 @@
       implicit none
 c
-!#include "dimensions.h"
-!#include "dimphys.h"
-!#include "chimiedata.h"
-!#include "conc.h"
-!#include "surfdat.h"
 c
 c     input
Index: trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90	(revision 1266)
@@ -31,13 +31,5 @@
 !    ------------------
 !
-!#include "dimensions.h"
-!#include "dimphys.h"
 #include "callkeys.h"
-!#include "comdiurn.h"
-!#include "param.h"
-!#include "param_v4.h"
-!#include "chimiedata.h"
-!#include "tracer.h"
-!#include "conc.h"
 !-----------------------------------------------------------------------
 !    Input/Output
@@ -413,5 +405,5 @@
          enddo
         !Routine to calculate the UV heating
-         call hrtherm (ig,euvmod,rm,nespeuv,tx,zlocal,zenit,zday,jtot)
+         call hrtherm (ig,nlayer,euvmod,rm,nespeuv,tx,zlocal,zenit,zday,jtot)
 
 !        euveff=0.16    !UV heating efficiency. Following Fox et al. ASR 1996
Index: trunk/LMDZ.MARS/libf/aeronomars/hrtherm.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/hrtherm.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/hrtherm.F	(revision 1266)
@@ -1,5 +1,6 @@
 c**********************************************************************
 
-      subroutine hrtherm(ig,euvmod,rm,nespeuv,tx,iz,zenit,zday,jtot)
+      subroutine hrtherm(ig,nlayer,
+     .      euvmod,rm,nespeuv,tx,iz,zenit,zday,jtot)
 
 
@@ -9,13 +10,9 @@
 c**********************************************************************
 
+      use param_v4_h, only: ninter,nabs,jfotsout,fluxtop,freccen
+
       implicit none
 
 c     common variables and constants
-
-
-      include 'dimensions.h'
-      include 'dimphys.h'
-      include 'param.h'
-      include 'param_v4.h'
       include "callkeys.h"
 
@@ -23,6 +20,6 @@
 c    local parameters and variables
 
-      real       xabsi(nabs,nlayermx) 			!densities
-      real       jergs(ninter,nabs,nlayermx)
+      real       xabsi(nabs,nlayer) 			!densities
+      real       jergs(ninter,nabs,nlayer)
       
       integer    i,j,k,indexint          !indexes
@@ -32,11 +29,11 @@
 c     input and output variables
 
-      integer    ig  ,euvmod 
+      integer    ig  ,euvmod,nlayer 
       integer    nespeuv
-      real       rm(nlayermx,nespeuv)              !density matrix (cm^-3)
-      real       jtot(nlayermx)                    !output: heating rate(erg/s)
-      real       tx(nlayermx)                      !temperature
+      real       rm(nlayer,nespeuv)              !density matrix (cm^-3)
+      real       jtot(nlayer)                    !output: heating rate(erg/s)
+      real       tx(nlayer)                      !temperature
       real       zenit
-      real       iz(nlayermx)
+      real       iz(nlayer)
       real       zday
 
@@ -67,5 +64,5 @@
       end if
       if(dn.eq.'n') then
-        do i=1,nlayermx                                    
+        do i=1,nlayer                                    
 	      jtot(i)=0.
         enddo       
@@ -78,5 +75,5 @@
       jtot(:)=0.
       !All number densities to a single array, xabsi(species,layer)
-      do i=1,nlayermx
+      do i=1,nlayer
          xabsi(1,i)  = rm(i,i_co2)
          xabsi(2,i)  = rm(i,i_o2)
@@ -102,11 +99,12 @@
       !Calculation of photoabsortion coefficient
       if(solvarmod.eq.0) then
-         call jthermcalc(ig,euvmod,rm,nespeuv,tx,iz,zenit)
+         call jthermcalc(ig,nlayer,euvmod,rm,nespeuv,tx,iz,zenit)
       else if (solvarmod.eq.1) then
-         call jthermcalc_e107(ig,euvmod,rm,nespeuv,tx,iz,zenit,zday)
+         call jthermcalc_e107(ig,nlayer,euvmod,
+     .           rm,nespeuv,tx,iz,zenit,zday)
       endif
 
       !Total photoabsorption coefficient
-      do i=1,nlayermx
+      do i=1,nlayer
          jtot(i)=0.
         do j=1,nabs
Index: trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 1266)
@@ -34,7 +34,5 @@
 
 #include "dimensions.h"
-!#include "dimphys.h"
 #include "paramet.h"
-!#include "tracer.h"
 #include "comvert.h"
 #include "callkeys.h"
Index: trunk/LMDZ.MARS/libf/aeronomars/iono_h.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/iono_h.F90	(revision 1266)
+++ trunk/LMDZ.MARS/libf/aeronomars/iono_h.F90	(revision 1266)
@@ -0,0 +1,108 @@
+MODULE iono_h
+
+      IMPLICIT NONE
+
+      character*1,save,allocatable :: o1d_eq(:)
+      character*1,save,allocatable :: ho2_eq(:)
+      character*1,save,allocatable :: oh_eq(:)
+      character*1,save,allocatable :: h_eq(:)
+      character*1,save,allocatable :: n2d_eq(:)
+      character*1,save,allocatable :: no2_eq(:)
+      character*1,save,allocatable :: o3_eq(:)
+      character*1,save,allocatable :: no_eq(:)
+      character*1,save,allocatable :: cplus_eq(:)
+      character*1,save,allocatable :: coplus_eq(:)
+      character*1,save,allocatable :: oplus_eq(:)
+      character*1,save,allocatable :: n2plus_eq(:)
+      character*1,save,allocatable :: hplus_eq(:)
+      character*1,save,allocatable :: co2plus_eq(:)
+      character*1,save,allocatable :: o2plus_eq(:)
+      character*1,save,allocatable :: noplus_eq(:)
+      character*1,save,allocatable :: nplus_eq(:)
+      character*1,save,allocatable :: hco2plus_eq(:)
+      real*8,save,allocatable ::   tauco2(:,:)
+      real*8,save,allocatable ::   tauo2(:,:)
+      real*8,save,allocatable ::   tauo3p(:,:)
+      real*8,save,allocatable ::   tauco(:,:)
+      real*8,save,allocatable ::   tauh(:,:)
+      real*8,save,allocatable ::   tauoh(:,:)
+      real*8,save,allocatable ::   tauho2(:,:)
+      real*8,save,allocatable ::   tauh2(:,:)
+      real*8,save,allocatable ::   tauh2o(:,:)
+      real*8,save,allocatable ::   tauo1d(:,:)
+      real*8,save,allocatable ::   tauh2o2(:,:)
+      real*8,save,allocatable ::   tauo3(:,:)
+      real*8,save,allocatable ::   taun(:,:)
+      real*8,save,allocatable ::   tauno(:,:)
+      real*8,save,allocatable ::   taun2(:,:)
+      real*8,save,allocatable ::   taun2d(:,:)
+      real*8,save,allocatable ::   tauno2(:,:)
+      real*8,save,allocatable ::   tauco2plus(:,:)
+      real*8,save,allocatable ::   tauoplus(:,:)
+      real*8,save,allocatable ::   tauo2plus(:,:)
+      real*8,save,allocatable ::   taucoplus(:,:)
+      real*8,save,allocatable ::   taucplus(:,:)
+      real*8,save,allocatable ::   taunplus(:,:) 
+      real*8,save,allocatable ::   taunoplus(:,:)
+      real*8,save,allocatable ::   taun2plus(:,:)
+      real*8,save,allocatable ::   tauhplus(:,:)
+      real*8,save,allocatable ::   tauhco2plus(:,:)
+
+      CONTAINS
+
+         SUBROUTINE allocate_param_iono(nlayer,nreact)
+
+           IMPLICIT NONE
+
+           INTEGER :: nreact
+           INTEGER :: nlayer
+
+           allocate(o1d_eq(nlayer))
+           allocate(ho2_eq(nlayer))
+           allocate(oh_eq(nlayer))
+           allocate(h_eq(nlayer))
+           allocate(n2d_eq(nlayer))
+           allocate(no2_eq(nlayer))
+           allocate(o3_eq(nlayer))
+           allocate(no_eq(nlayer))
+           allocate(cplus_eq(nlayer))
+           allocate(coplus_eq(nlayer))
+           allocate(oplus_eq(nlayer))
+           allocate(n2plus_eq(nlayer))
+           allocate(hplus_eq(nlayer))
+           allocate(co2plus_eq(nlayer))
+           allocate(o2plus_eq(nlayer))
+           allocate(noplus_eq(nlayer))
+           allocate(nplus_eq(nlayer))
+           allocate(hco2plus_eq(nlayer))
+           allocate(tauco2(nreact,nlayer))
+           allocate(tauo2(nreact,nlayer))
+           allocate(tauo3p(nreact,nlayer))
+           allocate(tauco(nreact,nlayer))
+           allocate(tauh(nreact,nlayer))
+           allocate(tauoh(nreact,nlayer))
+           allocate(tauho2(nreact,nlayer))
+           allocate(tauh2(nreact,nlayer))
+           allocate(tauh2o(nreact,nlayer))
+           allocate(tauo1d(nreact,nlayer))
+           allocate(tauh2o2(nreact,nlayer))
+           allocate(tauo3(nreact,nlayer))
+           allocate(taun(nreact,nlayer))
+           allocate(tauno(nreact,nlayer))
+           allocate(taun2(nreact,nlayer))
+           allocate(taun2d(nreact,nlayer))
+           allocate(tauno2(nreact,nlayer))
+           allocate(tauco2plus(nreact,nlayer))
+           allocate(tauoplus(nreact,nlayer))
+           allocate(tauo2plus(nreact,nlayer))
+           allocate(taucoplus(nreact,nlayer))
+           allocate(taucplus(nreact,nlayer))
+           allocate(taunplus(nreact,nlayer)) 
+           allocate(taunoplus(nreact,nlayer))
+           allocate(taun2plus(nreact,nlayer))
+           allocate(tauhplus(nreact,nlayer))
+           allocate(tauhco2plus(nreact,nlayer))
+         
+         END SUBROUTINE allocate_param_iono
+
+END MODULE iono_h
